## net.sf.saxon.instruct
Class FixedElement

    java.lang.Object
      net.sf.saxon.expr.ComputedExpression
          net.sf.saxon.instruct.Instruction
              net.sf.saxon.instruct.ParentNodeConstructor
                  net.sf.saxon.instruct.ElementCreator
                      net.sf.saxon.instruct.FixedElement

All Implemented Interfaces:
  Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator, TailCallReturner

public class FixedElement
extends ElementCreator

An instruction that creates an element node whose name is known statically. Used for literal results elements in XSLT, for direct element constructors in XQuery, and for xsl:element in cases where the name and namespace are known statically.

See Also:
  Serialized Form

Field Summary
`protected int[]` `namespaceCodes`

Fields inherited from class net.sf.saxon.instruct.ElementCreator
`inheritNamespaces`

Fields inherited from class net.sf.saxon.instruct.ParentNodeConstructor
`content`

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`FixedElement(int nameCode, int[] namespaceCodes, boolean inheritNamespaces, SchemaType schemaType, int validation)` Create an instruction that creates a new element node

Method Summary
`void` `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
`void` `display(int level, NamePool pool, java.io.PrintStream out)` Display this instruction as an expression, for diagnostics
`int[]` `getActiveNamespaces()` Callback to get a list of the intrinsic namespaces that need to be generated for the element.
`InstructionInfo` `getInstructionInfo()` Get InstructionInfo for this expression
`ItemType` `getItemType(TypeHierarchy th)` Get the type of the item returned by this instruction
`int` `getNameCode(XPathContext context)` Callback from the superclass ElementCreator to get the nameCode for the element name
`SchemaType` `getXSIType(StaticContext env)` Determine whether the element constructor creates a fixed xsi:type attribute, and if so, return the relevant type.
`protected void` `outputNamespaceNodes(XPathContext context, Receiver out)` Callback from the superclass ElementCreator to output the namespace nodes
`Expression` `simplify(StaticContext env)` Simplify an expression.

Methods inherited from class net.sf.saxon.instruct.ElementCreator
`computeSpecialProperties, evaluateItem, getImplementationMethod, getValidationMode, processLeavingTail, setValidationMode, suppressValidation`

Methods inherited from class net.sf.saxon.instruct.ParentNodeConstructor
`createsNewNodes, getCardinality, getContentExpression, getSchemaType, getValidationAction, isLazyConstruction, isNamespaceSensitive, iterateSubExpressions, optimize, promoteInst, setContentExpression, setLazyConstruction, setSchemaType, typeCheck`

Methods inherited from class net.sf.saxon.instruct.Instruction
`appendItem, assembleParams, assembleTunnelParams, computeCardinality, dynamicError, evaluateAsString, getInstructionNameCode, getSourceLocator, isXSLT, iterate, process, promote`

Methods inherited from class net.sf.saxon.expr.ComputedExpression

`adoptChildExpression, computeDependencies, computeStaticProperties, doPromotion, dynamicError, dynamicError, effectiveBooleanValue, getColumnNumber, getConstructType, getDependencies, getExecutable, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, resetStaticProperties, setLocationId, setParentExpression, typeError, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Field Detail

### namespaceCodes

    protected int[] namespaceCodes

Constructor Detail

### FixedElement

    public FixedElement(int nameCode,
                        int[] namespaceCodes,
                        boolean inheritNamespaces,
                        SchemaType schemaType,
                        int validation)

  Create an instruction that creates a new element node

Parameters:
  `nameCode` - Represents the name of the element node
  `namespaceCodes` - List of namespaces to be added to the element node. May be null if none are required.
  `inheritNamespaces` - true if the children of this element are to inherit its namespaces
  `schemaType` - Type annotation for the new element node

Method Detail

### getInstructionInfo

    public InstructionInfo getInstructionInfo()

  Description copied from class: `ComputedExpression`
  Get InstructionInfo for this expression

  Specified by:
    `getInstructionInfo` in interface `InstructionInfoProvider`
  Overrides:
    `getInstructionInfo` in class `Instruction`

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression).

  Specified by:
    `simplify` in interface `Expression`
  Overrides:
    `simplify` in class `ParentNodeConstructor`
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Get the type of the item returned by this instruction

  Specified by:
    `getItemType` in interface `Expression`
  Overrides:
    `getItemType` in class `ElementCreator`
  Parameters:
    `th` -
  Returns:
    the item type

### getNameCode

    public int getNameCode(XPathContext context)

  Callback from the superclass ElementCreator to get the nameCode for the element name

  Specified by:
    `getNameCode` in class `ElementCreator`
  Parameters:
    `context` - The evaluation context (not used)
  Returns:
    the name code for the element name

### getXSIType

    public SchemaType getXSIType(StaticContext env)
                          throws XPathException

  Determine whether the element constructor creates a fixed xsi:type attribute, and if so, return the relevant type.

  Returns:
    the type denoted by the constructor's xsi:type attribute if there is one. Return null if there is no xsi:type attribute, or if the value of the xsi:type attribute is a type that is not statically known (this is allowed)
  Throws:
    `XPathException` - if there is an xsi:type attribute and its value is not a QName.

### checkPermittedContents

    public void checkPermittedContents(SchemaType parentType,
                                       StaticContext env,
                                       boolean whole)
                                throws XPathException

  Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.

  Specified by:
    `checkPermittedContents` in interface `Expression`
  Overrides:
    `checkPermittedContents` in class `ComputedExpression`
  Throws:
    `XPathException`

### outputNamespaceNodes

    protected void outputNamespaceNodes(XPathContext context,
                                        Receiver out)
                                 throws XPathException

  Callback from the superclass ElementCreator to output the namespace nodes

  Specified by:
    `outputNamespaceNodes` in class `ElementCreator`
  Parameters:
    `context` - The evaluation context (not used)
    `out` - The receiver to handle the output
  Throws:
    `XPathException`

### getActiveNamespaces

    public int[] getActiveNamespaces()
                              throws XPathException

  Callback to get a list of the intrinsic namespaces that need to be generated for the element. The result is an array of namespace codes, the codes either occupy the whole array or are terminated by a -1 entry. A result of null is equivalent to a zero-length array.

  Overrides:
    `getActiveNamespaces` in class `ElementCreator`
  Throws:
    `XPathException`

### display

    public void display(int level,
                        NamePool pool,
                        java.io.PrintStream out)

  Display this instruction as an expression, for diagnostics

  Parameters:
    `level` - indentation level for this expression
    `pool` - NamePool used to expand any names appearing in the expression
    `out` - Output destination